
(function() {

	// 監視用ID
	var watchId;

	// 初期化
	function initBeacon() {
		applican.beacon.init(initBeaconSuccess, initBeaconError);
	}

	// 初期化成功
	function initBeaconSuccess(){
		var dump = "初期化成功"
		document.querySelector("#dumpAreaInit").value = dump;
	}

	// 初期化失敗
	function initBeaconError(error){
		var dump = "初期化失敗\n";
		dump += "code:" + error.code + "\n";
		document.querySelector("#dumpAreaInit").value = dump;
	}

	// 監視開始	
	function startMonitoring() {
		applican.beacon.startMonitoring(startMonitoringSuccess, startMonitoringError);
	}

	// 監視開始成功
	function startMonitoringSuccess(){
		var dump = "監視の開始成功";
		document.querySelector("#dumpAreaInit").value = dump;
	}

	// 監視開始失敗
	function startMonitoringError(error){
		var dump = "監視の開始失敗\n";
		dump += "エラーコード:" + error.code + "\n";
		document.querySelector("#dumpAreaInit").value = dump;
	}

	// 監視の終了	
	function stopMonitoring() {
		applican.beacon.stopMonitoring(stopMonitoringSuccess, stopMonitoringError);
	}

	// 監視の終了成功
	function stopMonitoringSuccess(){
		var dump = "監視の終了成功";
		document.querySelector("#dumpAreaInit").value = dump;
	}

	// 監視の終了失敗
	function stopMonitoringError(error){
		var dump = "監視の終了失敗\n";
		dump += "エラーコード:" + error.code + "\n";
		document.querySelector("#dumpAreaInit").value = dump;
	}

	// 監視状況の取得	
	function isMonitoring() {
		applican.beacon.isMonitoring(isMonitoringSuccess, isMonitoringError);
	}

	// 監視中
	function isMonitoringSuccess(){
		var dump = "監視中です";
		document.querySelector("#dumpAreaInit").value = dump;
	}

	// 監視中ではない
	function isMonitoringError(error){
		var dump = "監視中ではありません\n";
		document.querySelector("#dumpAreaInit").value = dump;
	}
	
	// リアルタイム監視
	function watchBeacon() {

		// 監視するビーコンの情報
		var beaconInfo = { uuid:'E2CAFB03-EB2C-436C-8978-E3815215B963', major:"1"};
		
		// ビーコンの監視の開始
		watchId = applican.beacon.watchBeacon(beaconInfo, watchBeaconResult, watchBeaconSuccess, watchBeaconError);
	}

	// 取得したビーコン情報。端末に依存しますがおよそ１秒ごとに取得されます。
	function watchBeaconResult(beacon){
			
		var uuid		= beacon.uuid;		// ビーコンの UUID
		var major		= beacon.major;		// ビーコンのメジャー番号
		var minor		= beacon.minor;		// ビーコンのマイナー番号
		var proximity	= beacon.proximity;	// 距離の精度（0:不明, 1:至近距離, 2:近距離, 3:遠距離）
		var accuracy	= beacon.accuracy;	// ビーコンまでの距離（メートル）
		var rssi		= beacon.rssi;		// 受信信号強度（dBm）
		var dump = "ビーコン情報:\n";
		dump += "uuid : " + uuid + "\n";
		dump += "major : " + major + "\n";
		dump += "minor : " + minor + "\n";
		dump += "proximity : " + proximity + "\n";
		dump += "accuracy : " + accuracy + "\n";
		dump += "rssi : " + rssi + "\n";
		document.querySelector("#dumpAreaWatchBeacon").value = dump;
	}

	// 監視開始成功
	function watchBeaconSuccess(){
		var dump = "リアルタイム監視成功\n";
		dump += "watch id : " + watchId;
		document.querySelector("#dumpAreaWatchBeaconInfo").value = dump;
	}

	// 監視開始失敗
	function watchBeaconError(error){
		var dump = "リアルタイム監視失敗\n";
		dump += "code:" + error.code + "\n";
		document.querySelector("#dumpAreaWatchBeaconInfo").value = dump;
	}

	// リアルタイム監視終了
	function clearBeacon() {
		applican.beacon.clearBeacon(watchId);

		var dump = "リアルタイム監視終了";
		document.querySelector("#dumpAreaWatchBeaconInfo").value = dump;
	}

	// 履歴取得
	function getBeaconHistory() {
		var beaconInfo = { uuid: 'E2CAFB03-EB2C-436C-8978-E3815215B963' };
		console.log("ok")
		applican.beacon.getBeaconHistory(beaconInfo, getBeaconHistorySuccess, getBeaconHistoryError);
	}

	// 履歴取得成功
	function getBeaconHistorySuccess(beacons){
	    var dump = '履歴取得成功\n';
	    console.log(beacons)
		for (var i in beacons) {
			var beacon = beacons[i];
            dump += '履歴: uuid=' + beacon.uuid + ',major=' + beacon.major + ',minor=' + beacon.minor + ',proximity=' + beacon.proximity + ',accuracy=' + beacon.accuracy + ',rssi=' + beacon.rssi + '\n';
		}

		document.querySelector("#dumpAreaHistory").value = dump;
	}

	// 履歴取得失敗
    function getBeaconHistoryError() {
		var dump = "履歴取得失敗";
		dump += "code:" + error.code + "\n";
		document.querySelector("#dumpAreaHistory").value = dump;
	}

	// applican 準備完了
	function onDeviceReady() {

		// 初期化
		document.querySelector("#initBtn").addEventListener("click", initBeacon);
		// 監視の開始
		document.querySelector("#startMonitoringBtn").addEventListener("click", startMonitoring);
		// 監視の終了
		document.querySelector("#stopMonitoringBtn").addEventListener("click", stopMonitoring);
		// 監視状況の取得
		document.querySelector("#isMonitoringBtn").addEventListener("click", isMonitoring);
		// リアルタイム監視
		document.querySelector("#watchBeaconBtn").addEventListener("click", watchBeacon);
		// リアルタイム監視終了
		document.querySelector("#clearBeaconBtn").addEventListener("click", clearBeacon);
		// 履歴取得
		document.querySelector("#getBeaconHistoryBtn").addEventListener("click", getBeaconHistory);

	}

	// applican の読み込み完了まで待機
	document.addEventListener("deviceready", onDeviceReady, false);

})();
